package org.linotte.frame.navinotte.protocole;

import java.io.File;
import java.io.IOException;

import javax.swing.SwingUtilities;

import org.linotte.frame.Atelier;
import org.linotte.frame.navinotte.protocole.i.Protocole;
import org.linotte.moteur.outils.Ressources;

public class Explorer implements Protocole {

	public final static String PROTOCOLE = "explorer://";

	private Atelier atelier;

	public Explorer(Atelier atelier) {
		this.atelier = atelier;

	}

	@Override
	public boolean can(String s) {
		return s.toLowerCase().startsWith(PROTOCOLE);
	}

	@Override
	public void handle(final String url) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				try {
					File p = new File(Ressources.getExemples(atelier.linotte.getLangage()), url.substring(PROTOCOLE.length()));
					java.awt.Desktop.getDesktop().open(p.getCanonicalFile());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		});
	}

}
