package org.linotte.greffons.ruby;

import org.jruby.javasupport.JavaEmbedUtils;
import org.jruby.runtime.builtin.IRubyObject;
import org.linotte.greffons.api.AKMethod;
import org.linotte.greffons.externe.Greffon;
import org.linotte.greffons.externe.Greffon.ObjetLinotte;
import org.linotte.greffons.outils.ObjetLinotteHelper;

public class RubyMethod implements AKMethod {

	private String method;
	private IRubyObject rubyObject;

	public RubyMethod(IRubyObject globValue, String key) {
		rubyObject = globValue;
		method = key;
	}

	@Override
	public ObjetLinotte appeler(Greffon greffon, ObjetLinotte... parametres) throws Exception {
		//rubyObject.getRuntime().;
		IRubyObject retour = rubyObject.callMethod(rubyObject.getRuntime().getCurrentContext(), method);
		Object javaRetour = JavaEmbedUtils.rubyToJava(retour);
		System.out.println("ruby retour : " + javaRetour);
		if (javaRetour instanceof String)
			return ObjetLinotteHelper.copy((String) javaRetour);
		else
			return null;
	}

	@Override
	public String parametres() {
		return "( ? )";
	}
}
